// Con_meErrorSetUserProc.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


#include <stdio.h>
#include <conio.h>

#include <memory.h>

extern "C"
{
#include "..\\medriver.h"
}

#include "..\\TestConsoleGeneric.h"

#ifdef WIN64

#pragma comment (lib, "..\\meIDSmain64.lib")

#else

#pragma comment (lib, "..\\meIDSmain.lib")

#endif

int __stdcall meUserErrorProc(char *pcFunctionName, int iErrorCode);

int _tmain(int argc, _TCHAR* argv[])
{
	// Call generic console function in parent directory to 
	// open system and list the available devices and subdevices.

    printf( "This program demonstrates the use of the ME-iDS function meErrorSetUserProc\n"
            "to install a user-defined error function which will be called automatically\n"
            "each time an API-function returns an error.\n"  
            "\n"
            "First of all the standard generic routine TestConsoleMEIDSProlog will be\n"
            "called to list all the ME-iDS devices found on the system\n"
            "\n"
            "Press any key to begin\n\n"                                                    );

    getch();

	int i_number_of_devices = TestConsoleMEIDSProlog();

	if(i_number_of_devices <= 0)
	{
		return(-1);
	}

    meErrorSetUserProc(meUserErrorProc); 

    printf( "The user defined error function has been installed\n"
            "\n"
            "You will now be asked repeatedly to enter a device number for which the\n"
            "API-routine meQueryNameDevice will be called. If you (deliberately) enter\n"
            "an invalid device number, then the routine will return an error, and the\n" 
            "error function we have just installed will be called automatically\n\n"        );

    char sz_name_device[ME_DEVICE_NAME_MAX_COUNT];

    char sz_buffer[64];

    while(true)
    {
		printf("Device number (RETURN to terminate): ");  

		gets(&sz_buffer[0]);

		printf("\n\n");
		
		if(sz_buffer[0] == 0)
		{
			break;
		}

        int index_device;
		
		if( (sscanf(&sz_buffer[0], "%d", &index_device) != 1 ) )
		{
			continue;
		}

        int i_error =  meQueryNameDevice(index_device, &sz_name_device[0], ME_DEVICE_NAME_MAX_COUNT);
        {
            if(i_error == ME_ERRNO_SUCCESS)
            {
                printf( "Device: %d - Name: %s\n\n",
                        index_device, &sz_name_device[0]);
            }
        }
    }

	meClose(0);
	
	printf(	"Press any key to terminate\n\n");

	getch();
			
	return 0;
}

int __stdcall meUserErrorProc(char *pcFunctionName, int iErrorCode)
{
    // Get a text message corresponding to the error code 
    
    char error_msg[ME_ERROR_MSG_MAX_COUNT];

	int i_error = meErrorGetMessage(iErrorCode, &error_msg[0], ME_ERROR_MSG_MAX_COUNT);

	if(i_error != ME_ERRNO_SUCCESS)
	{
		return(i_error);
	}

    // Print the name of the calling function, the error code and the error description 
    // on the screen.
    
    printf( "**** User-defined error function called\n\n"
            "**** Error calling function: %s - Error code: 0x%08X\n\n"
            "**** Error description: %s\n\n",
            pcFunctionName, iErrorCode, &error_msg[0]                   );

	return(ME_ERRNO_SUCCESS);
}

