// ME5xxxPPDIO.cpp : implementation file
//

#include "stdafx.h"
#include "Dlg_ME-5xxx.h"
#include "ME5xxxPPDIO.h"


// CME5xxxPPDIO dialog

IMPLEMENT_DYNAMIC(CME5xxxPPDIO, CPropertyPage)

CME5xxxPPDIO::CME5xxxPPDIO()
	: CME5xxxPP(CME5xxxPPDIO::IDD)
{

}

CME5xxxPPDIO::~CME5xxxPPDIO()
{
}

void CME5xxxPPDIO::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CME5xxxPPDIO, CPropertyPage)
	ON_CBN_SELCHANGE(IDC_COMBO_DIRECTION, &CME5xxxPPDIO::OnCbnSelchangeComboDirection)
	ON_BN_CLICKED(IDC_BUTTON_RESET, &CME5xxxPPDIO::OnBnClickedButtonReset)
	ON_BN_CLICKED(IDC_BUTTON_READ, &CME5xxxPPDIO::OnBnClickedButtonRead)
	ON_BN_CLICKED(IDC_BUTTON_WRITE, &CME5xxxPPDIO::OnBnClickedButtonWrite)
END_MESSAGE_MAP()


// CME5xxxPPDIO message handlers

BOOL CME5xxxPPDIO::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// TODO:  Add extra initialization here

	OnBnClickedButtonReset();

	return TRUE;  // return TRUE unless you set the focus to a control

	// EXCEPTION: OCX Property Pages should return FALSE
}

void CME5xxxPPDIO::OnCbnSelchangeComboDirection()
{
	// TODO: Add your control notification handler code here

	int i_cur_sel = ( (CComboBox*)( GetDlgItem(IDC_COMBO_DIRECTION) ) )->GetCurSel();

	int i_single_config;

	if(i_cur_sel == 0)
	{
		i_single_config = ME_SINGLE_CONFIG_DIO_INPUT ;
	}
	else // if(i_cur_sel == 1)
	{
		i_single_config = ME_SINGLE_CONFIG_DIO_OUTPUT ;
	}

	meIOSingleConfig(	m_iDeviceIndex,						// device index
						m_iSubdeviceIndex,					// sub-device index
						0,									// channel
						i_single_config,					// iSingleConfig
						ME_VALUE_NOT_USED,					// iRef 
						ME_VALUE_NOT_USED,					// iTrigChan
						ME_VALUE_NOT_USED,					// iTrigTypre
						ME_VALUE_NOT_USED,					// iTrigEdge
						ME_IO_SINGLE_CONFIG_DIO_WORD	);	// iFlags

	GetDlgItem(IDC_BUTTON_WRITE)->EnableWindow(i_cur_sel != 0);			
}



void CME5xxxPPDIO::OnBnClickedButtonReset()
{
	// TODO: Add your control notification handler code here

	int i_me_error = meIOResetSubdevice(m_iDeviceIndex, m_iSubdeviceIndex, ME_IO_RESET_SUBDEVICE_NO_FLAGS);

	( (CComboBox*)( GetDlgItem(IDC_COMBO_DIRECTION) ) )->SetCurSel(0);

	GetDlgItem(IDC_BUTTON_WRITE)->EnableWindow(FALSE);

	OnBnClickedButtonRead();
}

void CME5xxxPPDIO::OnBnClickedButtonRead()
{
	// TODO: Add your control notification handler code here

	meIOSingle_t io_single[1];

	io_single[0].iDevice = m_iDeviceIndex;

	io_single[0].iSubdevice = m_iSubdeviceIndex;
	io_single[0].iChannel	= 0;
	io_single[0].iDir		= ME_DIR_INPUT;
	io_single[0].iValue		= 0;
	io_single[0].iTimeOut	= 0;							// No timeout - not required for software output
	io_single[0].iFlags		= ME_IO_SINGLE_TYPE_DIO_WORD;
	
	int i_me_error = meIOSingle(&io_single[0],				// Output list 
								1,							// Number of elements in the above list 
								ME_IO_SINGLE_NO_FLAGS	);	// Flags

	int i_mask = 0x00000001;

	for(int index_bit = 0; index_bit < 16; index_bit++)
	{
		CheckDlgButton(IDC_CHECK_0 + index_bit, ( (io_single[0].iValue & i_mask) == i_mask ) ? BST_CHECKED : BST_UNCHECKED);

		i_mask<<= 1;
	}
}

void CME5xxxPPDIO::OnBnClickedButtonWrite()
{
	// TODO: Add your control notification handler code here

	int i_value = 0;

	int i_mask = 0x00000001;

	for(int index_bit = 0; index_bit < 16; index_bit++)
	{
		if(IsDlgButtonChecked(IDC_CHECK_0 + index_bit) != 0)
		{
			i_value|= i_mask;
		}

		i_mask<<= 1;
	}

	meIOSingle_t io_single[1];

	io_single[0].iDevice = m_iDeviceIndex;

	io_single[0].iSubdevice = m_iSubdeviceIndex;
	io_single[0].iChannel	= 0;
	io_single[0].iDir		= ME_DIR_OUTPUT;
	io_single[0].iValue		= i_value;
	io_single[0].iTimeOut	= 0;							// No timeout - not required for software output
	io_single[0].iFlags		= ME_IO_SINGLE_TYPE_DIO_WORD;
	
	int i_me_error = meIOSingle(&io_single[0],				// Output list 
								1,							// Number of elements in the above list 
								ME_IO_SINGLE_NO_FLAGS	);	// Flags
}
