// ME5xxxPPDO.cpp : implementation file
//

#include "stdafx.h"
#include "Dlg_ME-5xxx.h"
#include "ME5xxxPPDO.h"


#define UNIT_HZ		1
#define UNIT_KHZ	1000
#define UNIT_MHZ	1000000

struct SOutputRateEntry
{
	int	m_iUnit;

	int	m_iValue;
}
arrOutputRateEntries[] = {	{UNIT_HZ, 1},
								{UNIT_HZ, 10},
								{UNIT_HZ, 100},
								{UNIT_KHZ, 1},
								{UNIT_KHZ, 10},
								{UNIT_KHZ, 100},
								{UNIT_MHZ, 1},
								{UNIT_MHZ, 2},
								{UNIT_MHZ, 3},
								{UNIT_MHZ, 6},
								{UNIT_MHZ, 11},
								{UNIT_MHZ, 22},
								{UNIT_MHZ, 33}	};
// CME5xxxPPDO dialog

IMPLEMENT_DYNAMIC(CME5xxxPPDO, CPropertyPage)

CME5xxxPPDO::CME5xxxPPDO()
	: CME5xxxPP(CME5xxxPPDO::IDD)
{

}

CME5xxxPPDO::~CME5xxxPPDO()
{
}

void CME5xxxPPDO::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CME5xxxPPDO, CPropertyPage)
	ON_BN_CLICKED(IDC_RESET, &CME5xxxPPDO::OnBnClickedReset)
	ON_BN_CLICKED(IDC_SINGLE_CHECK_HARDWARE_TRIGGER, &CME5xxxPPDO::OnSingleBnClickedCheckHardwareTrigger)
	ON_BN_CLICKED(IDC_SINGLE_BUTTON_WRITE, &CME5xxxPPDO::OnSingleBnClickedButtonWrite)
	ON_BN_CLICKED(IDC_STREAMING_BUTTON_FILE_BROWSE, &CME5xxxPPDO::OnStreamingBnClickedButtonFileBrowse)
	ON_BN_CLICKED(IDC_STREAMING_CHECK_WRAPAROUND, &CME5xxxPPDO::OnStreamingBnClickedCheckWraparound)
	ON_BN_CLICKED(IDC_STREAMING_START_CHECK_HARDWARE_TRIGGER, &CME5xxxPPDO::OnStreamingBnClickedStartCheckHardwareTrigger)
	ON_BN_CLICKED(IDC_STREAMING_BUTTON_START, &CME5xxxPPDO::OnStreamingBnClickedButtonStart)
	ON_BN_CLICKED(IDC_STREAMING_BUTTON_WRITE, &CME5xxxPPDO::OnStreamingBnClickedButtonWrite)
	ON_BN_CLICKED(IDC_STREAMING_STOP_CHECK_HARDWARE_TRIGGER, &CME5xxxPPDO::OnStreamingBnClickedStopCheckHardwareTrigger)
	ON_BN_CLICKED(IDC_STREAMING_STOP_CHECK_STOP_AFTER, &CME5xxxPPDO::OnStreamingBnClickedStopCheckStopAfter)
	ON_BN_CLICKED(IDC_STREAMING_BUTTON_STOP, &CME5xxxPPDO::OnStreamingBnClickedButtonStop)
END_MESSAGE_MAP()


// CME5xxxPPDO message handlers

BOOL CME5xxxPPDO::OnInitDialog()
{
	CME5xxxPP::OnInitDialog();

	// TODO:  Add extra initialization here

	CheckDlgButton(IDC_SINGLE_CHECK_HARDWARE_TRIGGER, BST_UNCHECKED);

	OnSingleBnClickedCheckHardwareTrigger();

	SetDlgItemInt(IDC_SINGLE_EDIT_TIMEOUT, 1000);

	SetDlgItemInt(IDC_SINGLE_EDIT_VALUE, 0x00000000);

	for(int index_output_rate = 0; index_output_rate < sizeof(arrOutputRateEntries) / sizeof( arrOutputRateEntries[0] ); index_output_rate++)
	{
		CString cs_entry;

		cs_entry.Format(_T("%3d "), arrOutputRateEntries[index_output_rate].m_iValue);

		if(arrOutputRateEntries[index_output_rate].m_iUnit == UNIT_HZ)
		{
			cs_entry+= _T("Hz");
		}
		else if(arrOutputRateEntries[index_output_rate].m_iUnit == UNIT_KHZ)
		{
			cs_entry+= _T("kHz");
		}
		else // if(arrOutputRateEntries[index_output_rate].m_iUnit == UNIT_MHZ)
		{
			cs_entry+= _T("MHz");
		}

		( (CComboBox*)( GetDlgItem(IDC_STREAMING_COMBO_OUTPUT_RATE) ) )->AddString(cs_entry);
	}

	( (CComboBox*)( GetDlgItem(IDC_STREAMING_COMBO_OUTPUT_RATE) ) )->SetCurSel(3);	// 1 kHz

	CheckDlgButton(IDC_STREAMING_CHECK_WRAPAROUND, BST_UNCHECKED);

	OnStreamingBnClickedCheckWraparound();

	SetDlgItemInt(IDC_STREAMING_EDIT_NUMBER_OF_LOOPS, 0);

	SetDlgItemInt(IDC_STREAMING_EDIT_PRELOAD_NUMBER_OF_VALUES, 10000);

	CheckDlgButton(IDC_STREAMING_START_CHECK_HARDWARE_TRIGGER, BST_UNCHECKED);

	OnStreamingBnClickedStartCheckHardwareTrigger();

	SetDlgItemInt(IDC_STREAMING_START_EDIT_TIMEOUT, 1000);

	SetDlgItemInt(IDC_STREAMING_EDIT_WRITE_NUMBER_OF_VALUES, 10000);

	CheckDlgButton(IDC_STREAMING_STOP_CHECK_HARDWARE_TRIGGER, BST_UNCHECKED);

	OnStreamingBnClickedStopCheckHardwareTrigger();

	CheckDlgButton(IDC_STREAMING_STOP_CHECK_STOP_AFTER, BST_UNCHECKED);

	OnStreamingBnClickedStopCheckStopAfter();

	SetDlgItemInt(IDC_STREAMING_STOP_EDIT_AFTER_VALUES, 1000);

	/*
	meIOStreamSetCallbacks(m_iDeviceIndex, m_iSubdeviceIndex, 
									StreamingStartCallback, this, 
										StreamingNewValuesCallback, this, 
												StreamingEndCallback, this, 
													ME_IO_STREAM_SET_CALLBACKS_NO_FLAGS); 
	*/

	m_pDataFile = NULL;

	m_piDataBuffer = new int[0x10000];

	m_iDataBufferSize = 0x10000;

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CME5xxxPPDO::OnBnClickedReset()
{
	// TODO: Add your control notification handler code here

	int i_me_error = meIOResetSubdevice(m_iDeviceIndex, m_iSubdeviceIndex, ME_IO_RESET_SUBDEVICE_NO_FLAGS);
}

void CME5xxxPPDO::OnSingleBnClickedCheckHardwareTrigger()
{
	// TODO: Add your control notification handler code here

	if( IsDlgButtonChecked(IDC_SINGLE_CHECK_HARDWARE_TRIGGER) == 0)
	{
		GetDlgItem(IDC_SINGLE_TEXT_FALLING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_SINGLE_CHECK_TRIGGER_B_FALLING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_SINGLE_TEXT_RISING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_SINGLE_CHECK_TRIGGER_B_RISING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_SINGLE_TEXT_TIMEOUT)->EnableWindow(FALSE);

		GetDlgItem(IDC_SINGLE_EDIT_TIMEOUT)->EnableWindow(FALSE);

		GetDlgItem(IDC_SINGLE_TEXT_MS)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_SINGLE_TEXT_FALLING_EDGE)->EnableWindow(TRUE);

		GetDlgItem(IDC_SINGLE_CHECK_TRIGGER_B_FALLING_EDGE)->EnableWindow(TRUE);

		GetDlgItem(IDC_SINGLE_TEXT_RISING_EDGE)->EnableWindow(TRUE);

		GetDlgItem(IDC_SINGLE_CHECK_TRIGGER_B_RISING_EDGE)->EnableWindow(TRUE);

		GetDlgItem(IDC_SINGLE_TEXT_TIMEOUT)->EnableWindow(TRUE);

		GetDlgItem(IDC_SINGLE_EDIT_TIMEOUT)->EnableWindow(TRUE);

		GetDlgItem(IDC_SINGLE_TEXT_MS)->EnableWindow(TRUE);
	}
}

void CME5xxxPPDO::OnSingleBnClickedButtonWrite()
{
	// TODO: Add your control notification handler code here

	int i_trigger_type = 0;

	int i_trigger_edge = 0;

	int i_timeout = 0;

	if( IsDlgButtonChecked(IDC_SINGLE_CHECK_HARDWARE_TRIGGER) == 0)
	{
		i_trigger_type = ME_TRIG_TYPE_SW;

		i_trigger_edge = ME_VALUE_NOT_USED;

		i_timeout = 0x00000000;
	}
	else
	{
		i_trigger_type = ME_TRIG_TYPE_EXT_DIGITAL;

		if( IsDlgButtonChecked(IDC_SINGLE_CHECK_TRIGGER_B_RISING_EDGE) != 0 )
		{
			if( IsDlgButtonChecked(IDC_SINGLE_CHECK_TRIGGER_B_FALLING_EDGE) != 0 )
			{
				i_trigger_edge = ME_TRIG_EDGE_ANY;
			}
			else
			{
				i_trigger_edge = ME_TRIG_EDGE_RISING;
			}
		}
		else if( IsDlgButtonChecked(IDC_SINGLE_CHECK_TRIGGER_B_FALLING_EDGE) != 0 )
		{
			i_trigger_edge = ME_TRIG_EDGE_FALLING;
		}

		i_timeout = (int)GetDlgItemInt(IDC_SINGLE_EDIT_TIMEOUT);
	}

	int i_me_error = meIOSingleConfig(	m_iDeviceIndex,						// Device index
										m_iSubdeviceIndex,					// Subdevcie index
										0,									// Channel
										ME_SINGLE_CONFIG_DIO_OUTPUT,		// Single config
										ME_VALUE_NOT_USED,					// Reference 
										ME_TRIG_CHAN_DEFAULT,				// Trigger channel
										i_trigger_type,						// Trigger type
										i_trigger_edge,						// Trigger edge
										ME_IO_SINGLE_CONFIG_DIO_WORD	);	// Flags

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		SetDlgItemText( IDC_SINGLE_VALUE, _T("????") );

		return;
	}

	TCHAR sz_buffer[64];

	GetDlgItemText(IDC_SINGLE_EDIT_VALUE, &sz_buffer[0], 64);

	int i_value;

	if(_stscanf_s(&sz_buffer[0], _T("%X"), &i_value ) != 1)
	{
		AfxMessageBox(_T("Invalid Output value"), MB_OK | MB_ICONEXCLAMATION); 

		return;
	}

	meIOSingle_t io_single[1];

	io_single[0].iDevice = m_iDeviceIndex;

	io_single[0].iSubdevice = m_iSubdeviceIndex;
	io_single[0].iChannel	= 0;
	io_single[0].iDir		= ME_DIR_OUTPUT;
	io_single[0].iValue		= i_value;
	io_single[0].iTimeOut	= i_timeout;							
	io_single[0].iFlags		= ME_IO_SINGLE_TYPE_DIO_WORD;
	
	i_me_error = meIOSingle(&io_single[0],				// Output list 
							1,							// Number of elements in the above list 
							ME_IO_SINGLE_NO_FLAGS	);	// Flags
}


void CME5xxxPPDO::OnStreamingBnClickedButtonFileBrowse()
{
	// TODO: Add your control notification handler code here

	CFileDialog dlg(TRUE, L".m5d", NULL, OFN_FILEMUSTEXIST, L"m5d-Dateien (*.m5d)|*.m5d||");

	if(dlg.DoModal() == IDOK)
	{
		GetDlgItem(IDC_STREAMING_EDIT_FILE_NAME)->SetWindowText( dlg.GetPathName() );
	}
}

void CME5xxxPPDO::OnStreamingBnClickedCheckWraparound()
{
	// TODO: Add your control notification handler code here

	if( IsDlgButtonChecked(IDC_STREAMING_CHECK_WRAPAROUND) == 0)
	{
		GetDlgItem(IDC_STREAMING_TEXT_NUMBER_OF_LOOPS)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_EDIT_NUMBER_OF_LOOPS)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_TEXT_0_EQUALS_INFINITE)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_STREAMING_TEXT_NUMBER_OF_LOOPS)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_EDIT_NUMBER_OF_LOOPS)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_TEXT_0_EQUALS_INFINITE)->EnableWindow(TRUE);
	}
}

void CME5xxxPPDO::OnStreamingBnClickedStartCheckHardwareTrigger()
{
	// TODO: Add your control notification handler code here

	if( IsDlgButtonChecked(IDC_STREAMING_START_CHECK_HARDWARE_TRIGGER) == 0)
	{
		GetDlgItem(IDC_STREAMING_START_TEXT_FALLING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_RISING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_TRIGGER_B)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_CHECK_TRIGGER_B_FALLING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_CHECK_TRIGGER_B_RISING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_CHECK_OUTPUT_ONE_VALUE_PER_TRIGGER)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_TIMEOUT)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_EDIT_TIMEOUT)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_MS)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_STREAMING_START_TEXT_FALLING_EDGE)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_TEXT_RISING_EDGE)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_TEXT_TRIGGER_B)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_CHECK_TRIGGER_B_FALLING_EDGE)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_CHECK_TRIGGER_B_RISING_EDGE)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_CHECK_OUTPUT_ONE_VALUE_PER_TRIGGER)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_TEXT_TIMEOUT)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_EDIT_TIMEOUT)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_TEXT_MS)->EnableWindow(TRUE);
	}
}

void CME5xxxPPDO::OnStreamingBnClickedButtonStart()
{
	// TODO: Add your control notification handler code here

	_TCHAR sz_message[_MAX_PATH + 64];

	if(m_pDataFile != NULL)
	{
		fclose(m_pDataFile);
		
		m_pDataFile = NULL;
	}

	TCHAR sz_file_name[_MAX_PATH];

	GetDlgItemText(IDC_STREAMING_EDIT_FILE_NAME, &sz_file_name[0], _MAX_PATH);

	if( (_tfopen_s( &m_pDataFile, &sz_file_name[0], _T("rb") ) != 0)||(m_pDataFile == NULL) )
	{
		_stprintf_s( &sz_message[0], _MAX_PATH + 64, _T("Cannot open file: <%s>"), &sz_file_name[0] );

		AfxMessageBox(&sz_message[0], MB_OK | MB_ICONEXCLAMATION);

		return;
	}

	int i_number_of_values = GetDlgItemInt(IDC_STREAMING_EDIT_PRELOAD_NUMBER_OF_VALUES);

	if(i_number_of_values <= 0)
	{
		_stprintf_s(&sz_message[0], _MAX_PATH + 64, _T("Invalid nmber of values: %d"), i_number_of_values);

		AfxMessageBox(&sz_message[0], MB_OK | MB_ICONEXCLAMATION);

		return;
	}

	if(m_iDataBufferSize < i_number_of_values)
	{
		if(m_piDataBuffer != NULL)
		{
			delete m_piDataBuffer;

			m_piDataBuffer = NULL;
		}

		m_iDataBufferSize = i_number_of_values * 3 / 2;

		m_piDataBuffer = new int[m_iDataBufferSize];
	}

	LoadDataBuffer(i_number_of_values);

    // Configure the device

	int i_index_output_rate = ( (CComboBox*)( GetDlgItem(IDC_STREAMING_COMBO_OUTPUT_RATE) ) )->GetCurSel();

	double d_freq = (double)arrOutputRateEntries[i_index_output_rate].m_iValue;

	if(arrOutputRateEntries[i_index_output_rate].m_iUnit == UNIT_KHZ)
	{
		d_freq*= 1000.0;
	}
	else if(arrOutputRateEntries[i_index_output_rate].m_iUnit == UNIT_MHZ)
	{
		d_freq*= 1000000.0;
	}

	int i_conv_ticks_low = 0;
	int i_conv_ticks_high = 0;

	int i_me_error = meIOStreamFrequencyToTicks(m_iDeviceIndex,						// Device index
												m_iSubdeviceIndex,					// Subdevice indexe, 
												ME_TIMER_CONV_START,				// Timer used 
												&d_freq,							// Required frequency Hz, Achieved frequency returned here	 
												&i_conv_ticks_low,					// Lower 32 bits of the corresponding tick value returned here
												&i_conv_ticks_high,					// Upper 32 bits of the corresponding tick value returned here
												ME_IO_FREQUENCY_TO_TICKS_NO_FLAGS); // No flags

	meIOStreamConfig_t arr_stream_config[1];

	arr_stream_config[0].iChannel = 0;

	arr_stream_config[0].iStreamConfig = 0;
	arr_stream_config[0].iRef = ME_REF_AO_GROUND;
	arr_stream_config[0].iFlags = ME_IO_STREAM_CONFIG_TYPE_NO_FLAGS;

	meIOStreamTrigger_t stream_trigger;

	memset( &stream_trigger, 0, sizeof(meIOStreamTrigger_t) );

	int b_value_per_trigger = 0;

	if( IsDlgButtonChecked(IDC_STREAMING_START_CHECK_HARDWARE_TRIGGER) == 0)
	{
		stream_trigger.iAcqStartTrigType = ME_TRIG_TYPE_SW;
	}
	else
	{
		stream_trigger.iAcqStartTrigType = ME_TRIG_TYPE_EXT_DIGITAL;
	
		if( IsDlgButtonChecked(IDC_STREAMING_START_CHECK_TRIGGER_B_RISING_EDGE) != 0 )
		{
			if( IsDlgButtonChecked(IDC_STREAMING_START_CHECK_TRIGGER_B_FALLING_EDGE) != 0 )
			{
				stream_trigger.iAcqStartTrigEdge = ME_TRIG_EDGE_ANY;
			}
			else
			{
				stream_trigger.iAcqStartTrigEdge = ME_TRIG_EDGE_RISING;
			}
		}
		else if( IsDlgButtonChecked(IDC_STREAMING_START_CHECK_TRIGGER_B_FALLING_EDGE) != 0 )
		{
			stream_trigger.iAcqStartTrigEdge = ME_TRIG_EDGE_FALLING;
		}

		if(IsDlgButtonChecked(IDC_STREAMING_CHECK_ACQUIRE_ONE_VALUE_PER_TRIGGER) != 0)
		{
			b_value_per_trigger = 1;
		}
	}
	
	stream_trigger.iAcqStartTrigChan = ME_TRIG_CHAN_DEFAULT;
	stream_trigger.iAcqStartTicksLow = 0;
	stream_trigger.iAcqStartTicksHigh = 0;
	// int iAcqStartArgs[10];

	stream_trigger.iScanStartTrigType = ME_TRIG_TYPE_FOLLOW;
	//int iScanStartTicksLow;
	//int iScanStartTicksHigh;
	//int iScanStartArgs[10];

	if(b_value_per_trigger == 0)
	{
		stream_trigger.iConvStartTrigType = ME_TRIG_TYPE_TIMER;

		stream_trigger.iConvStartTicksLow = i_conv_ticks_low;
		stream_trigger.iConvStartTicksHigh = i_conv_ticks_high;
	}
	else
	{
		stream_trigger.iConvStartTrigType = ME_TRIG_TYPE_EXT_DIGITAL;

		stream_trigger.iConvStartTicksLow = 0;
		stream_trigger.iConvStartTicksHigh = 0;
	}

	//int iConvStartArgs[10];

	// int iScanStopTrigType;
	// int iScanStopCount;
	// int iScanStopArgs[10];

	if(IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_HARDWARE_TRIGGER) != 0)
	{
		stream_trigger.iAcqStopTrigType = ME_TRIG_TYPE_EXT_DIGITAL;
		
		stream_trigger.iAcqStopArgs[0] = 0x00000000;

		int i_mask = 0x00000001;

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			if( IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_FALLING_EDGE_0 + index_bit) != 0 )
			{
				stream_trigger.iAcqStopArgs[0]|= i_mask;
			}

			i_mask<<= 1;
		}
	
		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			if( IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_RISING_EDGE_0 + index_bit) != 0 )
			{
				stream_trigger.iAcqStopArgs[0]|= i_mask;
			}

			i_mask<<= 1;
		}

		stream_trigger.iAcqStopArgs[1] = 0x00000000;

		if( IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_TRIGGER_B_FALLING_EDGE) != 0 )
		{
			stream_trigger.iAcqStopArgs[1]|= 0x00000001;
		}

		if( IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_TRIGGER_B_RISING_EDGE) != 0 )
		{
			stream_trigger.iAcqStopArgs[1]|= 0x00010000;
		}
	}

	int b_wraparound = (IsDlgButtonChecked(IDC_STREAMING_CHECK_WRAPAROUND) == 0) ? 0 : 1;
	
	if(b_wraparound != 0)
	{
		stream_trigger.iAcqStopTrigType = ME_TRIG_TYPE_COUNT;

		stream_trigger.iAcqStopCount = GetDlgItemInt(IDC_STREAMING_EDIT_NUMBER_OF_LOOPS);
	}

	// int iAcqStopTrigType;
	// int iAcqStopCount;
	// int iAcqStopArgs[10];

	stream_trigger.iFlags = ME_IO_STREAM_TRIGGER_TYPE_NO_FLAGS;
		
	int i_stream_config_flags = (b_wraparound == 0) ? ME_IO_STREAM_CONFIG_NO_FLAGS : ME_IO_STREAM_CONFIG_WRAPAROUND;

	i_me_error = meIOStreamConfig(	m_iDeviceIndex,				// Device index
									m_iSubdeviceIndex,			// Subdevice index, 
									&arr_stream_config[0],		// Pointer to an array of meIOStreamConfig_t structures
									1,							// Number of elements in the stream config array above
									&stream_trigger,			// Pointer to an meIOStreamTrigger_t structure
									0,							// FIFO IRQ threshold - not used here
									i_stream_config_flags	);	// No flags

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		return;
	}

	i_me_error = meIOStreamWrite(	m_iDeviceIndex,					// Device index
									m_iSubdeviceIndex,				// Subdevice index, 
									ME_WRITE_MODE_PRELOAD,			// Write mode 
									&m_piDataBuffer[0],				// Buffer containing the values to write
									&i_number_of_values,			// Size of buffer in data values - Number of data values returned here
									ME_IO_STREAM_WRITE_NO_FLAGS	);	// No flags

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		return;
	}


	int i_time_out_ms = 0;

	if(IsDlgButtonChecked(IDC_STREAMING_START_CHECK_HARDWARE_TRIGGER) != 0)
	{
		i_time_out_ms = GetDlgItemInt(IDC_STREAMING_START_EDIT_TIMEOUT);
	}
	
	meIOStreamStart_t arr_stream_start[1];

	arr_stream_start[0].iDevice = m_iDeviceIndex;
	arr_stream_start[0].iSubdevice = m_iSubdeviceIndex;
	arr_stream_start[0].iStartMode = ME_START_MODE_BLOCKING;
	arr_stream_start[0].iTimeOut = i_time_out_ms;
	arr_stream_start[0].iFlags = ME_IO_STREAM_START_TYPE_NO_FLAGS;
	arr_stream_start[0].iErrno = 0;
	
	i_me_error = meIOStreamStart(	&arr_stream_start[0],			// Pointer to an array of meIOStreamStart_t structures 
									1,								// Number of elements in the stream start array above
									ME_IO_STREAM_START_NO_FLAGS	);	// No flags

	if( (i_me_error != ME_ERRNO_SUCCESS)&&(m_pDataFile != NULL) )
	{
		fclose(m_pDataFile);

		m_pDataFile = NULL;
	}
}

void CME5xxxPPDO::OnStreamingBnClickedButtonWrite()
{
	// TODO: Add your control notification handler code here

	int i_number_of_values = GetDlgItemInt(IDC_STREAMING_EDIT_WRITE_NUMBER_OF_VALUES);

	if(i_number_of_values <= 0)
	{
		_TCHAR sz_message[64];

		_stprintf_s(&sz_message[0], 64, _T("Invalid number of values: %d"), i_number_of_values);

		AfxMessageBox(&sz_message[0], MB_OK | MB_ICONEXCLAMATION);

		return;
	}

	if(m_iDataBufferSize < i_number_of_values)
	{
		if(m_piDataBuffer != NULL)
		{
			delete m_piDataBuffer;

			m_piDataBuffer = NULL;
		}

		m_iDataBufferSize = i_number_of_values * 3 / 2;

		m_piDataBuffer = new int[m_iDataBufferSize];
	}

	LoadDataBuffer(i_number_of_values);

	int i_me_error = meIOStreamWrite(	m_iDeviceIndex,					// Device index
										m_iSubdeviceIndex,				// Subdevice index, 
										ME_WRITE_MODE_BLOCKING,			// Write mode 
										&m_piDataBuffer[0],				// Buffer containing the values to write
										&i_number_of_values,			// Size of buffer in data values - Number of data values returned here
										ME_IO_STREAM_WRITE_NO_FLAGS	);	// No flags
}

void CME5xxxPPDO::OnStreamingBnClickedStopCheckHardwareTrigger()
{
	// TODO: Add your control notification handler code here

	if( IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_HARDWARE_TRIGGER) == 0)
	{
		GetDlgItem(IDC_STREAMING_STOP_TEXT_PORT_B)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_TRIGGER_B)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_0)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_4)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_8)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_12)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_FALLING_EDGE)->EnableWindow(FALSE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_STOP_CHECK_FALLING_EDGE_0 + index_bit)->EnableWindow(FALSE);
		}

		GetDlgItem(IDC_STREAMING_STOP_TEXT_RISING_EDGE)->EnableWindow(FALSE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_STOP_CHECK_RISING_EDGE_0 + index_bit)->EnableWindow(FALSE);
		}

		GetDlgItem(IDC_STREAMING_STOP_TEXT_TRIGGER_B)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_CHECK_TRIGGER_B_FALLING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_CHECK_TRIGGER_B_RISING_EDGE)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_STREAMING_STOP_TEXT_PORT_B)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_TRIGGER_B)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_0)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_4)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_8)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_12)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_FALLING_EDGE)->EnableWindow(TRUE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_STOP_CHECK_FALLING_EDGE_0 + index_bit)->EnableWindow(TRUE);
		}

		GetDlgItem(IDC_STREAMING_STOP_TEXT_RISING_EDGE)->EnableWindow(TRUE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_STOP_CHECK_RISING_EDGE_0 + index_bit)->EnableWindow(TRUE);
		}

		GetDlgItem(IDC_STREAMING_STOP_TEXT_TRIGGER_B)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_CHECK_TRIGGER_B_FALLING_EDGE)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_CHECK_TRIGGER_B_RISING_EDGE)->EnableWindow(TRUE);
	}
}

void CME5xxxPPDO::OnStreamingBnClickedStopCheckStopAfter()
{
	// TODO: Add your control notification handler code here

	if( IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_STOP_AFTER) == 0)
	{
		GetDlgItem(IDC_STREAMING_STOP_EDIT_AFTER_VALUES)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_AFTER_VALUES)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_STREAMING_STOP_EDIT_AFTER_VALUES)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_AFTER_VALUES)->EnableWindow(TRUE);
	}
}

void CME5xxxPPDO::OnStreamingBnClickedButtonStop()
{
	// TODO: Add your control notification handler code here

	meIOStreamStop_t arr_stream_stop[1];

	arr_stream_stop[0].iDevice = m_iDeviceIndex;
	arr_stream_stop[0].iSubdevice = m_iSubdeviceIndex;
	arr_stream_stop[0].iStopMode = ME_STOP_MODE_IMMEDIATE;
	arr_stream_stop[0].iFlags = ME_IO_STREAM_STOP_TYPE_NO_FLAGS;
	arr_stream_stop[0].iErrno = 0;

	int i_me_error = meIOStreamStop(&arr_stream_stop[0],			// Pointer to an array of meIOStreamStop_t structures  
									1,								// Number of elements in the stream stop array above
									ME_IO_STREAM_STOP_NO_FLAGS);	// No flags
}

int __stdcall CME5xxxPPDO :: StreamingStartCallback(int iDevice, int iSubdevice, int iCount, void *pvContext, int iErrorCode)
{
	if(iErrorCode != ME_ERRNO_SUCCESS)
	{
		return iErrorCode;
	}
	
	CME5xxxPPDO* p_me5xxx_pp_do = (CME5xxxPPDO*)pvContext;

//	p_me5xxx_pp_di->SetDlgItemText( IDC_TEXT_ACQUISITION_STATUS, _T("Aquisition running") );
	
	return ME_ERRNO_SUCCESS;
}

int __stdcall CME5xxxPPDO :: StreamingNewValuesCallback(int iDevice, int iSubdevice, int iCount, void *pvContext, int iErrorCode)
{
	if(iErrorCode != ME_ERRNO_SUCCESS)
	{
		return iErrorCode;
	}
	
	CME5xxxPPDO* p_me5xxx_pp_do = (CME5xxxPPDO*)pvContext;

OutputDebugString(L"\n\n\n************\n\n       StreamingNewValuesCallback\n\n************\n\n\n");

	return ME_ERRNO_SUCCESS;
}

int __stdcall CME5xxxPPDO :: StreamingEndCallback(int iDevice, int iSubdevice, int iCount, void *pvContext, int iErrorCode)
{
	CME5xxxPPDO* p_me5xxx_pp_do = (CME5xxxPPDO*)pvContext;
	
//	TCHAR sz_buffer[256];

//	_stprintf_s(&sz_buffer[0], 64, _T("Aquisition terminated - %d values written to file"), p_me5xxx_pp_di->m_iDataFileSize);

//	p_me5xxx_pp_di->SetDlgItemText( IDC_TEXT_ACQUISITION_STATUS, &sz_buffer[0] );

	return iErrorCode;
}

int CME5xxxPPDO :: LoadDataBuffer(int iNumberOfValues)
{
	if(m_pDataFile == NULL)
	{
		return -1;
	}

	int i_buffer_index = 0;

	while(iNumberOfValues > 0)
	{
		int i_bytes_read = (int)fread(&m_piDataBuffer[i_buffer_index], sizeof(int), iNumberOfValues, m_pDataFile);

		if(i_bytes_read < iNumberOfValues)
		{
			if(feof(m_pDataFile) == 0)
			{
				// read error 

				return -1;
			}

			rewind(m_pDataFile);
		}

		iNumberOfValues-= i_bytes_read;

		i_buffer_index+= i_bytes_read;
	}

	return 0;
}



