// TestDialog_StreamRead_CallbackDlg.h : header file
//

#pragma once

extern "C"
{
#include "..\\medriver.h"
}


#define MAX_STREAMING_SUBDEVICES	2

#define MAX_CHANNELS				4

// CTestDialog_StreamRead_CallbackDlg dialog
class CTestDialog_StreamRead_CallbackDlg : public CDialog
{
// Construction
public:
	CTestDialog_StreamRead_CallbackDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_TESTDIALOG_STREAMREAD_CALLBACK_DIALOG };

	protected:

	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	int m_iNumberOfAIStreamingSubdevices;
	
	struct SAIStreamingSubdevice
	{
		int m_iDeviceNumber;

		int m_iSubdeviceNumber;
	}
	m_arrAIStreamingSubdevices[MAX_STREAMING_SUBDEVICES];

	CRect m_rectPlot[MAX_STREAMING_SUBDEVICES];

	struct SAIChannel
	{
		bool	m_bEnabled;
		
		int		m_iChannelIndex;

		int		m_iRangeIndex;
	}
	m_arrAIChannels[MAX_STREAMING_SUBDEVICES][MAX_CHANNELS];

	COLORREF m_crChannelColors[MAX_STREAMING_SUBDEVICES][MAX_CHANNELS];

	double	m_dWindowWidthSec[MAX_STREAMING_SUBDEVICES];

	double	m_dWindowMinVolt[MAX_STREAMING_SUBDEVICES];

	double	m_dWindowMaxVolt[MAX_STREAMING_SUBDEVICES];

	double	m_dRequiredFreq[MAX_STREAMING_SUBDEVICES];

	double	m_dAchievedFreq[MAX_STREAMING_SUBDEVICES];

	struct SAIChannelRange
	{
		double m_dMin;

		double m_dMax;

		int m_iMaxData;
	}
	m_arrAIChannelRange[MAX_STREAMING_SUBDEVICES][MAX_CHANNELS];

	// Internal variables
	
	int m_iNumberOfChannels[MAX_STREAMING_SUBDEVICES];
	
	meIOStreamConfig_t m_arrStreamConfig[MAX_STREAMING_SUBDEVICES][MAX_CHANNELS];

	double m_dXIncrement[MAX_STREAMING_SUBDEVICES];

	double m_dYConstant[MAX_STREAMING_SUBDEVICES][MAX_CHANNELS];

	double m_dYFactor[MAX_STREAMING_SUBDEVICES][MAX_CHANNELS];

	bool	m_bFirstDraw[MAX_STREAMING_SUBDEVICES];
	
	double	m_dXLastPixel[MAX_STREAMING_SUBDEVICES];
	
	int		m_iXLastPixel[MAX_STREAMING_SUBDEVICES];
	
	int		m_iYLastPixel[MAX_STREAMING_SUBDEVICES][MAX_CHANNELS];

	CFont m_fontLarge;
	CFont m_fontExtraLarge;

private:

	static int _stdcall StreamReadNewValuesCallback(int iDevice, int iSubdevice, int iCount, void *pvContext, int iErrorCode);

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedStart();
public:
	afx_msg void OnBnClickedStop();
public:
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
public:
	afx_msg void OnStnClickedLocalDaq();
protected:
	virtual void OnCancel();
};
